﻿/*
* jHtree Horizontal Animated jQuery Plugin
* 4/2014 
* By NADy:   @naadydev     naadydev@gmail.com
*/
jQuery(function ($) {

    jQuery(document).ready(function(){
        createNewTree(jQuery('#tree'));
    })

    let options = {
        callType: 'url',
        url: '../wp-content/plugins/entusiastics_quiz_game/admin/js/data/myJsonFile.json',
        structureObj: [{}],
        zoomer: false,
        afterDropClass: 'contaftrdrop'
    }

    function createUpdate(element) {
        parentthis = element;

        if (options.callType == 'url') {
            jQuery.getJSON(options.url, function (data) {

            })
            .done(function (data) {

                constructTree(data, element);

            })
            .fail(function (err) {
                var status = err.status;
                var statusText = err.statusText;
            });
        }
        if (options.callType == 'obj') {
            constructTree(options.structureObj);
        }
    }

    function createNewTree(element) {
        createUpdate(element);
    }

    function constructTree(jsonStructureObject, element) {

        var $tree = jQuery(element);
        $tree.addClass('tree').append("<ul id='tremainul'>");

        walkerCursor(jsonStructureObject, 'tremainul');
        prepareNodes(element);
        treeDarg(element);
        treeDrop(element);
        interactionEvents();
        if (options.zoomer) zoomer($tree);
    }

    function walkerCursor(jsonObjs, parentLiNode) {
        for (var i = 0; i < jsonObjs.length; i++) {
            var node = jsonObjs[i];

            createNode(node, parentLiNode);

            if (node.children !== null && typeof node.children === "object") {
                walkerCursor(node.children, node.id);
            }
        }
    }


    function createNode (node, parentLiNode) {
        var bfrul = '';
        var isTreemainLi = (parentLiNode === "tremainul");
        var beforeDiv = '';
        var afterDiv = '';
        if (node.children) {
            bfrul = '<div class="bfrul"></div>';
        }
        if (!isTreemainLi) {
            beforeDiv = '<div class="before"><div class="funcbtnb ui-state-default ui-corner-all" title="Level Focus" data-func="focus"><span class="ui-icon ui-icon-zoomin"></span></div></div>';
            afterDiv = '<div class="after"><div class="funcbtna ui-state-default ui-corner-all" title="collapse" data-func="clps"><span class="ui-icon ui-icon-triangle-1-n"></span></div></div>';
        }

        var nodeLiElements = '<li id="' + node.id + '" class="tnode" >' + beforeDiv + '<div class="trcont"><div class="ui-widget-header ui-corner-tl ui-corner-tr">' +
        node.head + '</div><div class="ui-widget-content ui-corner-bl ui-corner-br">' +
        node.contents + '</div></div><div class="trchl"><ul>' +
        bfrul + '</ul></div>' + afterDiv + '</li>';

            if (isTreemainLi) {// Firest ul
                jQuery("#" + parentLiNode).append(nodeLiElements);
            }
            else {
                jQuery("> .trchl > ul", "#" + parentLiNode).append(nodeLiElements);
            }
        }

        function prepareNodes(element) {

            jQuery('.trchl').each(function (e, x) {
                var $obj = jQuery(element);

                var $li = jQuery($obj).find('> ul>li');
                var count = $li.length;

                if (count == 1)
                {
                    jQuery($li).find('> .before, > .after').css("border-top", "0px");
                }
                if (count > 1) {
                    $li.first().find('> .after').css("border-top", "0px");
                    $li.last().find('> .before').css("border-top", "0px");
                }

                var chldinsidlicount = $li.find('.trchl');


                $obj.find('div[data-func]').each(function (a, o) {
                    var objbtn = jQuery(o);
                    if (objbtn.data('func') == "reset") {
                        objbtn.show();
                        var objfocus = objbtn.parent().closest('li');
                        var objother = objfocus.parent().find('> li');
                        var targetobjs = jQuery(objother).not(objfocus);
                        targetobjs.hide();
                    }

                    if (objbtn.data('func') == "xpnd") {
                        objbtn.show();
                        objbtn.parent().parent().find('.trchl').hide();
                    }


                });

            });
        }
        function treeDarg(element) {

            jQuery("li", ".tree").draggable({

                cancel: "a.ui-icon", 
                revert: "invalid", 
                revertDuration: 600,
                containment: "document",

                helper: function (event, ui) {

                    var orginalElement = jQuery(element);
                    var header = orginalElement.find('> .trcont').find('.ui-widget-header');
                    var headerCopy = header.text();
                    return jQuery('<div class="ui-state-focus ui-corner-all" />').css("width", header.css("width")).text(headerCopy);


                },
                cursor: "move",
                distance: 20,
                opacity: 0.8,
                snap: '.trcont',
                snapMode: 'inner',
                stack: '.trcont',
                start: function (event, ui) { },
                stop: function (event, ui) { }
            });

        }

        function treeDrop(element) {

            var thisparent = element;

            jQuery("li", ".tree").draggable({

                greedy: true,
                accept: ".tree ul > li",
                activeClass: "dragactive",
                hoverClass: 'drophover',
                drop: function (event, ui) {


                    var draggableObj = ui.draggable;
                    var droppableObj = jQuery(element);

                    var draggableId = draggableObj.attr("id");
                    var droppableId = droppableObj.attr("id");


                    var $ItemUL = jQuery("ul:first", droppableObj);

                    if ($ItemUL.length) {


                        if (!$ItemUL.find('> .bfrul').length) {
                            $ItemUL.append('<div class="bfrul"></div>');
                        }
                        //---------------
                        jQuery(draggableObj).fadeOut("slow", function () {
                            jQuery(this).appendTo($ItemUL).fadeIn('slow')
                            .effect('shake', { direction: 'down', mode: 'effect' }, 'slow');
                            jQuery(this).find("> .trcont").addClass(thisparent.options.afterDropClass);


                        });
                        

                    }                                     
                    prepareNodesAfterDrop(draggableObj, droppableObj);                   
                    thisparent._trigger("nodeDropComplete", null, { nodeId: draggableId, parentNodeId: droppableId });                   
                }
            });
            function prepareNodesAfterDrop(movedObj, targetObj) {

                var parentUl = $(movedObj).parent();
                var parentLis = parentUl.find('> li');
                var objIndex = movedObj.index();
                if (parentLis.length == 1)
                {

                    jQuery('.bfrul', parentUl).fadeOut("slow", function () {
                        jQuery(this).remove();
                    });
                }
                if (parentLis.length > 1)
                {
                    var $besideLi;

                    if (objIndex == 1)
                    {

                        $besideLi = jQuery(movedObj).next('li');
                        if (parentLis.length == 2) {
                            $besideLi.find('> .before ,> .after').css("border-top", "0px");
                        }
                        else
                        {
                            $besideLi.find('> .after').css("border-top", "0px");
                        }
                    }
                    if (objIndex == parentLis.length)
                    {
                        $besideLi = jQuery(movedObj).prev('li');
                        if (parentLis.length == 2) {
                            $besideLi.find('> .before ,> .after').css("border-top", "0px");
                        }
                        else
                        {
                            $besideLi.find('> .before').css("border-top", "0px");
                        }
                    }
                }

                var $targetlis = $(targetObj).find('> .trchl > ul > li');

                if ($targetlis.length == 0)
                {
                    jQuery(movedObj).find('> .before ,> .after').css("border-top", "0px");
                }
                else 
                {
                    jQuery(movedObj).find('> .before').css("border-top", "0px");
                    jQuery(movedObj).find('> .after').css("border-top", "1px solid #ccc");

                    var $lastLi = $targetlis.last();
                    $lastLi.find("> .before").css("border-top", "1px solid #ccc");
                }
            }

        }

        function interactionEvents(element) {

            jQuery(".tree").on({
                mouseenter: function () {
                    var parentLi = jQuery(element).parent();

                    parentLi.find('> .before,> .after').find('> .funcbtnb,> .funcbtna').show('blind', { direction: 'vertical' });

                    parentLi.find('.ui-widget-content').addClass('tfocus');
                    parentLi.find('.ui-widget-header').addClass('ui-state-focus');
                },
                mouseleave: function () {

                    var parentLi = jQuery(element).parent();
                    parentLi.find('.ui-widget-content').removeClass('tfocus');
                    parentLi.find('.ui-widget-header').removeClass('ui-state-focus');

                }
            }, ".trcont,.before,.after");

            jQuery(".tree").on('mouseleave', '.tnode', function () {

                var funcbtns = jQuery(element).find('> .before,> .after').find('div[data-func]');
                if (jQuery(funcbtns[0]).data('func') == "focus") {
                    jQuery(funcbtns[0]).hide('blind', { direction: 'vertical' });
                }
                if (jQuery(funcbtns[1]).data('func') == "clps") {
                    jQuery(funcbtns[1]).hide('blind', { direction: 'vertical' });
                }

            });

            $(".tree").on("click", ".trcont > .ui-widget-header", function () {
                jQuery(element).parent().parent().find('.trchl').slideToggle('slow', "easeOutBounce", function () {
                    // Animation complete.
                });
            });

            $(".tree").on("click", "div[data-func]", function () {
                var objbtn = $(element);
                var objfocus = objbtn.parent().closest('li');
                var objother = objfocus.parent().find('> li');
                var targetobjs = $(objother).not(objfocus);

                var objfuncattr = objbtn.data("func");
                if (objfuncattr == 'focus' || objfuncattr == 'reset') {



                    objbtn.find('span').toggleClass('ui-icon-zoomin ui-icon-zoomout');
                    if (objfuncattr == 'focus') {


                        targetobjs.effect('fold', { direction: 'up', mode: 'hide' }, 'normal');

                        objbtn.data("func", "reset");
                        objbtn.attr("title", "Level Reset");
                    }
                    else {

                        targetobjs.effect('fold', { direction: 'up', mode: 'show' }, 'slow');
                        objbtn.data("func", "focus");
                        objbtn.attr("title", "Level Focus");
                    }
                }

                if (objfuncattr == 'clps' || objfuncattr == 'xpnd') {

                    objbtn.find('span').toggleClass("ui-icon-triangle-1-n ui-icon-triangle-1-s");
                    if (objfuncattr == 'clps') {
                        jQuery(element).parent().parent().find('.trchl').effect('fold', { direction: 'up', mode: 'hide' }, 'slow');
                        objbtn.data('func', 'xpnd');
                        objbtn.attr("title", "Expand");
                    } else {

                        jQuery(element).parent().parent().find('.trchl').slideDown('slow', "easeOutBounce", function () { });

                        objbtn.data('func', 'clps');
                        objbtn.attr("title", "Collapse");
                    }
                }
            });

        }

        // function zoomer(treeDiv) {
        //     var zmr = '<div class="zmrcntr"><input type="text" id="zmrval" class="zomrval"><div id="zmrslidr" style="height:200px;"></div></div>';
        //     $(zmr).insertBefore($(treeDiv));

        //     var brwstp = navigator.userAgent.match(/Mozilla/);
        //     $("#zmrslidr").slider({
        //         orientation: "vertical",
        //         range: "min",
        //         min: 10,
        //         animate: 'slow',
        //         max: 200,
        //         value: 100,
        //         slide: function (event, ui) {
        //             $("#zmrval").val(ui.value);
        //             if (brwstp == true) {

        //                 $('.tree').css('MozTransform', 'scale(' + ui.value + ')');
        //             } else {

        //                 $('.tree').css('zoom', ' ' + ui.value + '%');
        //             }
        //         }
        //     });
        //     $("#zmrval").val($("#zmrslidr").slider("value"));
        // }

    });