<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://entusiastics.com
 * @since      1.0.0
 *
 * @package    Entusiastics_Quiz_Game
 * @subpackage Entusiastics_Quiz_Game/admin/models
 */

if( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class Objective {
	
	function manage($vars, $quiz_id) {

		global $wpdb;
		
		// edit/delete existing objectives
		$sql = $wpdb->prepare("SELECT * FROM ".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES." WHERE quiz_id=%d", $quiz_id);
		$objectives = $wpdb->get_results($sql);
		
		foreach($objectives as $objective) {

			if(!empty($vars['dels']) and in_array($objective->id, $vars['dels'])) {
				$wpdb->query($wpdb->prepare("DELETE FROM ".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES." WHERE id=%d", $objective->id));
				continue;
			}
			
			$objective_title = strip_tags($vars['objective_title'.$objective->id]);
			$objective_description = strip_tags($vars['objective_description'.$objective->id]);

			// else update
			$result = $wpdb->query($wpdb->prepare("UPDATE ".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES." SET
				name=%s, description=%s, quiz_id=%d WHERE id=%d", $objective_title, $objective_description, $quiz_id, $objective->id));

			if($result === false) throw new Exception(__('DB Error', 'entusiastics-quiz-game'));
		}

		if(!empty($vars['objectives'])) {

			$counter = 0;
			foreach($vars['objectives'] as $objective) {

				$objective_title = $vars['objective_title'][$counter];
				$objective_description = $vars['objective_description'][$counter];

				if($objective_title == '' && $objective_description == '') {
					continue;
				}
				// now insert the objective
				$result = $wpdb->query( $wpdb->prepare("INSERT INTO ".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES." SET name=%s, description=%s, quiz_id=%d ", $objective_title, $objective_description, $quiz_id));

				if($result === false) throw new Exception(__('DB Error', 'entusiastics-quiz-game'));

				$counter++;
			}

		}

	} // end add

	public function getObjectivesByQuizId($quiz_id) {
		global $wpdb;

		$sql = $wpdb->prepare("SELECT * FROM ".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES." WHERE quiz_id=%d", $quiz_id);
		$objectives = $wpdb->get_results($sql);

		return $objectives;
	}

} 