<?php

/**
 * Related Quizzes partial.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package Entusiastics_Quiz_Game
 * @subpackage Entusiastics_Quiz_Game/public/templates/partials
 */

if ( ! defined( 'ABSPATH' ) ) { exit; } // Exit if accessed directly 

?>

<div id="entusiastics-quizzes-grid-container" class="entusiastics-quizzes-grid-container">

	<div class="entusiastics-quizzes-grid-wrapper">

		<div class="entusiastics-quizzes-grid-title-wrapper">
			<div class="entusiastics-quizzes-grid-title">
				<h3><?php _e('Juegos de aprendizaje', 'entusiastics-quiz-game') ?></h3>
			</div>
		</div>

		<div class="entusiastics-quizzes-grid-content">

			<div class="entusiastics-quizzes-grid-box-wrapper">

				<?php foreach ($args['related_quizzes'] as $related_quiz) {

					if(!empty($related_quiz->post)) {
						$is_published = true;
						$link = get_permalink($related_quiz->post->ID);
					}

					if($is_published && ($related_quiz->id != $args['quiz']->id)) { ?>

						<a class="entusiastics-quizzes-grid-button" href="<?php echo $link;?>" alt="<?php echo $related_quiz->title; ?>">

							<div class="entusiastics-quizzes-grid-box">

								<div class="entusiastics-quizzes-grid-box-top" style="background-color: <?php echo $related_quiz->theme_color; ?>; background-image: url('<?php echo $related_quiz->image_url;?>');">
									<div class="entusiastics-quizzes-grid-box-top-overlay" style="background-color:<?php echo $related_quiz->theme_color; ?>;"></div>
								</div>

								<div class="entusiastics-quizzes-grid-box-body">

									<div class="entusiastics-quizzes-grid-box-title-wrapper">
										<h4 class="entusiastics-quizzes-grid-box-title">
											<?php echo $related_quiz->title; ?>
										</h4>
									</div>

									<div class="entusiastics-quizzes-grid-box-duration">

										<span class="entusiastics-quizzes-grid-box-icon">
											<img src="<?php echo ENTUSIASTICS_QUIZ_GAME_PUBLIC_URL.'assets/images/reloj-gray.svg'?>" alt="Clock Icon" />
										</span>

										<?php 

										// parse time
										$parsed_duration = entusiastics_quiz_game_parse_time($related_quiz->duration);

										?>

										<span class="entusiastics-quizzes-grid-box-time-text"><?php echo $parsed_duration; ?></span>

									</div>
								</div>

							</div>

						</a>

					<?php }

					$is_published = false;
				} ?>

			</div>

		</div>	

	</div>

</div>